# -*- coding: utf-8 -*- #
# Django's views file.
#
# Copyright (C) 2010 Osama Khalid osamak.wfm[at]gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from youogg.add.models import files
from django.shortcuts import render_to_response
from datetime import datetime
import re, random, string, youogg.utilities, youogg.plugins
from django.core.urlresolvers import reverse
from django.http import HttpResponseRedirect
from youogg.watch.views import watch
from django.utils.translation import ugettext as _

def frontPage(request):
  context = {}

  if request.POST.has_key('URL'):
    for host in xrange(len(youogg.plugins.hosts)):
      matchingRe = re.match(youogg.plugins.hosts.keys()[host], request.POST['URL']) #Try out every URL regex to find the right one (if any).
      if matchingRe:
        orgID = matchingRe.groupdict()['video_id'] # Extract the Video ID from the URL.
        orgHost = youogg.plugins.hosts.values()[host] # The hosting website name. For example, 'YouTube'.
        if request.POST.has_key('hd'): isHD=True
        else: isHD=False
        if request.POST.has_key('hidden'): isHidden=True
        else: isHidden=False
        if request.POST.has_key('type'):
          if request.POST['type'] == 'audio':
            localType = 'audio'
          else:
            localType = 'video'
        try: #If the video already exists, it didn't fail, and it is not hidden, redirect to it.
          fileObject = files.objects.get(orgID=orgID, orgHost=orgHost, isHD=isHD, localType=localType, isHidden=False, status__in=['done','downloaded','downloading','converting', 'queue'])
          return HttpResponseRedirect(reverse('youogg.watch.views.watch',args=[fileObject.videoID]))
        except files.DoesNotExist:
          break
    else: # If no Regex matched.
        context = {'message':_('You entered an incorrect/unsupported URL: ') + '(<i>' + request.POST['URL'] + '</i>).'}
  else: # If there is no POST data
    context = {'message':_('Please enter the Flash video URL below.')}

  if context == {}: # No error occurred.
    #if the form sets the video id and the video is either expired or failed, just change its status and redirect to it.
    if request.POST.has_key('videoid'): 
      try:
        videoID = request.POST['videoid']
        fileObject = files.objects.get(videoID=videoID)
        if fileObject.status in ['expired', 'failed']:
          fileObject.status = 'queue'
          fileObject.save()
          return HttpResponseRedirect(reverse('youogg.watch.views.watch',args=[videoID]))
      except files.DoesNotExist:
        pass
    # If it doesn't or if the ID isn't correct, generate one.
    while True:
      videoID = "".join([random.choice(string.digits + string.letters) for x in xrange(5)])
      if files.objects.filter(videoID=videoID): #Very rarely expected, if there is already a video has the same videoID.
        continue
      else: # The general case.
        break
    files.objects.create(videoID=videoID, title=videoID, orgID=orgID, orgHost=orgHost, localType=localType, status='queue', upload_date=datetime.now(), isHD=isHD, isHidden=isHidden)
    if request.GET.has_key('ext'):
      return HttpResponseRedirect(reverse('youogg.add.views.confirm_youtube',args=[orgID]) + "?ext=1&hight=%s&width=%s" % (request.GET['width'], request.GET['hight']))
      
    orgURL = youogg.plugins.pageURLs[orgHost] % orgID
    context = {'orgURL': orgURL, 'id': videoID}

  return render_to_response('upload.html',context)

def confirm_youtube(request, youtube_id):
  context = {'youtube_id':youtube_id}
  if len(youtube_id) != 11:
    context = {'message':_('You followed an incorrect converting link.')}
  if request.GET.has_key('ext'):
    try:
      fileObject = files.objects.get(orgID=youtube_id,orgHost="YouTube")
      #return HttpResponseRedirect(reverse('youogg.watch.views.watch', args=[fileObject.videoID])+"?ext=1")
      return watch(request, fileObject.videoID, True, request.GET['hight'], request.GET['width'])
    except files.DoesNotExist:
      pass
    context.update({'hight':request.GET['hight'],'width':request.GET['width']})
    return render_to_response('confirm-ext.html', context)
  else:
    try:
      fileObject = files.objects.get(orgID=youtube_id,orgHost="YouTube")
      return HttpResponseRedirect(reverse('youogg.watch.views.watch',args=[fileObject.videoID]))
    except files.DoesNotExist:
      pass
    return render_to_response('confirm.html', context)
