# -*- coding: utf-8 -*- #
# Usage: python delete.py id1 [id2 id3 ...]
#
# Copyright (C) 2010 Osama Khalid osamak.wfm[at]gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
import settings, sys, os
from django.core.management import setup_environ
setup_environ(settings)
from add.models import files
from utilities import output

def deleteIDs(ids, status='deleted', isHidden=True):
  for videoID in ids:
    try:
      output("Deleting " + videoID)
      video = files.objects.get(videoID=videoID)
      localType = video.localType
      video.status = status
      if isHidden: # deleteold.py doesn't need to change isHidden.
        video.isHidden = True
      video.save()
      # You'll need to change the following to the files directory.
      if localType == "video": localType = ".ogv"
      elif localType == "audio": localType = ".oga"
      filePath = os.path.join('/home/osamak/webapps/files', videoID + localType)
      os.remove(filePath)
      output(videoID + " deleted.")
    except (files.DoesNotExist, OSError):
      output(videoID + " does not exist.")

if __name__ == '__main__':
  deleteIDs(sys.argv[1:])
