# -*- coding: utf-8 -*- #
# This file will be scheduled to run every one minute using cron to work
# on the waiting-list videos.
#
# Copyright (C) 2008, 2009 Leonardo Gastón De Luca leo[at]kde.org.ar
# Copyright (C) 2010 Osama Khalid osamak.wfm[at]gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import re, utilities

hosts = {
         re.compile(r'^http://(www\.|(.){2}\.)?youtube\.com/watch\?v=(?P<video_id>.{11})'): 'YouTube',
         #re.compile(r''),'',
        }

pageURLs = {# display name and the URL in a form similar to http://example.com/video?q=<video_id>
             'YouTube': 'http://www.youtube.com/watch?v=%s',
            }

class Plugin:
  def gettitle(self):
    return
  def getDownloadURL(self):
    return

class YouTube(Plugin):
  "YouTube Plugin"
  def __init__(self, video_id):
    self.token = ''
    self.url = pageURLs['YouTube'] % video_id
    self.page_text = utilities.opener.open(self.url).read()
    self.video_id = video_id
    open('lastest','w').write(self.page_text)
  def gettitle(self):
    try:
      title = re.findall(re.compile("<h1 (dir='rtl')?>(.*?)</h1>"), self.page_text)[0][1]
    except IndexError:
      title = self.video_id
    return title

  def getDownloadURL(self, isHD, errorcounter):
    if isHD: #FIXME: ugly hack.
      if errorcounter == 0:
        quality = '&fmt=22'
      elif errorcounter == 1:
        quality = '&fmt=35'
      elif errorcounter == 2:
        quality = '&fmt=18'
      elif errorcounter == 3:
        quality = ''
    else:
      quality = ''
    try:
      token = self.page_text[self.page_text.index('"t"'):][6:52]
      downloadURL = 'http://www.youtube.com/get_video.php?video_id=%(orgID)s&t=%(token)s%(quality)s&eurl=&el=detailpage&ps=default&gl=US&hl=en' % {'orgID': self.video_id, 'token': token, 'quality': quality}
      return downloadURL
    except ValueError:
      print "No token."
      return
