# -*- coding: utf-8 -*- #
# Django's urls file.
#
# Copyright (C) 2010 Osama Khalid osamak.wfm[at]gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls.defaults import *
from youogg.add.models import files

info_dict = {
    'queryset': files.objects.exclude(isHidden=True).order_by('id').reverse()[:50],
}
info_dict.update({'template_name':'list.html'})
# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()

urlpatterns = patterns('',
    (r'^add/', include('youogg.add.urls')),
    (r'^watch/add_comment/$', 'django.views.generic.simple.redirect_to', {'url':'/youogg/add/'}),
    (r'^watch/add_comment/', include('django.contrib.comments.urls')),
    (r'^watch/$', 'django.views.generic.simple.redirect_to', {'url':'/youogg/add/'}),
    (r'^watch/(?P<video_id>[a-zA-Z0-9]{5})/$', 'youogg.watch.views.watch'),
    ('^tos/$','django.views.generic.simple.direct_to_template',{'template':'tos.html'}),
    ('^privacy/$','django.views.generic.simple.direct_to_template',{'template':'privacy.html'}),
    ('^about/$','django.views.generic.simple.direct_to_template',{'template':'about.html'}),
    ('^about/faqs/$','django.views.generic.simple.direct_to_template',{'template':'faqs.html'}),
    ('^about/source/$','django.views.generic.simple.direct_to_template',{'template':'source.html'}),
    (r'^list/$', 'django.views.generic.list_detail.object_list', info_dict),
    (r'^random$', 'youogg.watch.views.random'),
    ('^$','django.views.generic.simple.direct_to_template',{'template':'index.html'}),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs' 
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    (r'^admin/', include(admin.site.urls)),
)
